/*
* Copyright (C) 2007-2013 German Aerospace Center (DLR/SC)
*
* Created: 2013-10-29 Martin Siggel <Martin.Siggel@dlr.de>
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

#include "TIGLViewerLogRedirection.h"

#include <QString>
#include <QApplication>

TIGLViewerLogRedirection::TIGLViewerLogRedirection() : verbosity(TILOG_DEBUG4) {}

void TIGLViewerLogRedirection::LogMessage(TiglLogLevel level, const char * message)
{
    if (level<=verbosity) {
        emit newMessage(QString(message));
        QCoreApplication::processEvents();
    }
}

void TIGLViewerLogRedirection::SetVerbosity(TiglLogLevel vlevel)
{
    verbosity=vlevel;
}
