// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include "tigl_internal.h"

namespace tigl
{
    namespace generated
    {
        // This class is used in:
        // CPACSSparCell
        
        // generated from /xsd:schema/xsd:complexType[317]
        class CPACSEtaIsoLine
        {
        public:
            TIGL_EXPORT CPACSEtaIsoLine();
            TIGL_EXPORT virtual ~CPACSEtaIsoLine();
            
            TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
            TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;
            
            TIGL_EXPORT virtual const double& GetEta() const;
            TIGL_EXPORT virtual void SetEta(const double& value);
            
            TIGL_EXPORT virtual const std::string& GetReferenceUID() const;
            TIGL_EXPORT virtual void SetReferenceUID(const std::string& value);
            
        protected:
            double      m_eta;
            std::string m_referenceUID;
            
        private:
            #ifdef HAVE_CPP11
            CPACSEtaIsoLine(const CPACSEtaIsoLine&) = delete;
            CPACSEtaIsoLine& operator=(const CPACSEtaIsoLine&) = delete;
            
            CPACSEtaIsoLine(CPACSEtaIsoLine&&) = delete;
            CPACSEtaIsoLine& operator=(CPACSEtaIsoLine&&) = delete;
            #else
            CPACSEtaIsoLine(const CPACSEtaIsoLine&);
            CPACSEtaIsoLine& operator=(const CPACSEtaIsoLine&);
            #endif
        };
    }
    
    // Aliases in tigl namespace
    #ifdef HAVE_CPP11
    using CCPACSEtaIsoLine = generated::CPACSEtaIsoLine;
    #else
    typedef generated::CPACSEtaIsoLine CCPACSEtaIsoLine;
    #endif
}
