// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "CPACSFuselageCutOut.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
    namespace generated
    {
        CPACSFuselageCutOut::CPACSFuselageCutOut(CTiglUIDManager* uidMgr) :
            m_uidMgr(uidMgr), 
            m_positionX(0), 
            m_referenceY(0), 
            m_referenceZ(0), 
            m_referenceAngle(0), 
            m_orientationVector(m_uidMgr), 
            m_deltaY(0), 
            m_deltaZ(0), 
            m_filletRadius(0) {}
        
        CPACSFuselageCutOut::~CPACSFuselageCutOut()
        {
            if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
        }
        
        CTiglUIDManager& CPACSFuselageCutOut::GetUIDManager()
        {
            return *m_uidMgr;
        }
        
        const CTiglUIDManager& CPACSFuselageCutOut::GetUIDManager() const
        {
            return *m_uidMgr;
        }
        
        void CPACSFuselageCutOut::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
        {
            // read attribute uID
            if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
                m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
                if (m_uID.empty()) {
                    LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
                }
            }
            else {
                LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
            }
            
            // read element name
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/name")) {
                m_name = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/name");
                if (m_name->empty()) {
                    LOG(WARNING) << "Optional element name is present but empty at xpath " << xpath;
                }
            }
            
            // read element description
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/description")) {
                m_description = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/description");
                if (m_description->empty()) {
                    LOG(WARNING) << "Optional element description is present but empty at xpath " << xpath;
                }
            }
            
            // read element positionX
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/positionX")) {
                m_positionX = tixi::TixiGetElement<double>(tixiHandle, xpath + "/positionX");
            }
            else {
                LOG(ERROR) << "Required element positionX is missing at xpath " << xpath;
            }
            
            // read element referenceY
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/referenceY")) {
                m_referenceY = tixi::TixiGetElement<double>(tixiHandle, xpath + "/referenceY");
            }
            else {
                LOG(ERROR) << "Required element referenceY is missing at xpath " << xpath;
            }
            
            // read element referenceZ
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/referenceZ")) {
                m_referenceZ = tixi::TixiGetElement<double>(tixiHandle, xpath + "/referenceZ");
            }
            else {
                LOG(ERROR) << "Required element referenceZ is missing at xpath " << xpath;
            }
            
            // read element referenceAngle
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/referenceAngle")) {
                m_referenceAngle = tixi::TixiGetElement<double>(tixiHandle, xpath + "/referenceAngle");
            }
            else {
                LOG(ERROR) << "Required element referenceAngle is missing at xpath " << xpath;
            }
            
            // read element orientationVector
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/orientationVector")) {
                m_orientationVector.ReadCPACS(tixiHandle, xpath + "/orientationVector");
            }
            else {
                LOG(ERROR) << "Required element orientationVector is missing at xpath " << xpath;
            }
            
            // read element alignmentVector
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/alignmentVector")) {
                m_alignmentVector = boost::in_place(m_uidMgr);
                try {
                    m_alignmentVector->ReadCPACS(tixiHandle, xpath + "/alignmentVector");
                } catch(const std::exception& e) {
                    LOG(ERROR) << "Failed to read alignmentVector at xpath " << xpath << ": " << e.what();
                    m_alignmentVector = boost::none;
                }
            }
            
            // read element deltaY
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaY")) {
                m_deltaY = tixi::TixiGetElement<double>(tixiHandle, xpath + "/deltaY");
            }
            else {
                LOG(ERROR) << "Required element deltaY is missing at xpath " << xpath;
            }
            
            // read element deltaZ
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaZ")) {
                m_deltaZ = tixi::TixiGetElement<double>(tixiHandle, xpath + "/deltaZ");
            }
            else {
                LOG(ERROR) << "Required element deltaZ is missing at xpath " << xpath;
            }
            
            // read element deltaY1
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaY1")) {
                m_deltaY1 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/deltaY1");
            }
            
            // read element deltaZ1
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaZ1")) {
                m_deltaZ1 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/deltaZ1");
            }
            
            // read element filletRadius
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/filletRadius")) {
                m_filletRadius = tixi::TixiGetElement<double>(tixiHandle, xpath + "/filletRadius");
            }
            else {
                LOG(ERROR) << "Required element filletRadius is missing at xpath " << xpath;
            }
            
            // read element cutoutType
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/cutoutType")) {
                m_cutoutType = stringToCPACSFuselageCutOut_cutout(tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/cutoutType"));
            }
            else {
                LOG(ERROR) << "Required element cutoutType is missing at xpath " << xpath;
            }
            
            if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
        }
        
        void CPACSFuselageCutOut::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
        {
            // write attribute uID
            tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);
            
            // write element name
            if (m_name) {
                tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/name");
                tixi::TixiSaveElement(tixiHandle, xpath + "/name", *m_name);
            } else {
                if (tixi::TixiCheckElement(tixiHandle, xpath + "/name")) {
                    tixi::TixiRemoveElement(tixiHandle, xpath + "/name");
                }
            }
            
            // write element description
            if (m_description) {
                tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/description");
                tixi::TixiSaveElement(tixiHandle, xpath + "/description", *m_description);
            } else {
                if (tixi::TixiCheckElement(tixiHandle, xpath + "/description")) {
                    tixi::TixiRemoveElement(tixiHandle, xpath + "/description");
                }
            }
            
            // write element positionX
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/positionX");
            tixi::TixiSaveElement(tixiHandle, xpath + "/positionX", m_positionX);
            
            // write element referenceY
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/referenceY");
            tixi::TixiSaveElement(tixiHandle, xpath + "/referenceY", m_referenceY);
            
            // write element referenceZ
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/referenceZ");
            tixi::TixiSaveElement(tixiHandle, xpath + "/referenceZ", m_referenceZ);
            
            // write element referenceAngle
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/referenceAngle");
            tixi::TixiSaveElement(tixiHandle, xpath + "/referenceAngle", m_referenceAngle);
            
            // write element orientationVector
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/orientationVector");
            m_orientationVector.WriteCPACS(tixiHandle, xpath + "/orientationVector");
            
            // write element alignmentVector
            if (m_alignmentVector) {
                tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/alignmentVector");
                m_alignmentVector->WriteCPACS(tixiHandle, xpath + "/alignmentVector");
            } else {
                if (tixi::TixiCheckElement(tixiHandle, xpath + "/alignmentVector")) {
                    tixi::TixiRemoveElement(tixiHandle, xpath + "/alignmentVector");
                }
            }
            
            // write element deltaY
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/deltaY");
            tixi::TixiSaveElement(tixiHandle, xpath + "/deltaY", m_deltaY);
            
            // write element deltaZ
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/deltaZ");
            tixi::TixiSaveElement(tixiHandle, xpath + "/deltaZ", m_deltaZ);
            
            // write element deltaY1
            if (m_deltaY1) {
                tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/deltaY1");
                tixi::TixiSaveElement(tixiHandle, xpath + "/deltaY1", *m_deltaY1);
            } else {
                if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaY1")) {
                    tixi::TixiRemoveElement(tixiHandle, xpath + "/deltaY1");
                }
            }
            
            // write element deltaZ1
            if (m_deltaZ1) {
                tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/deltaZ1");
                tixi::TixiSaveElement(tixiHandle, xpath + "/deltaZ1", *m_deltaZ1);
            } else {
                if (tixi::TixiCheckElement(tixiHandle, xpath + "/deltaZ1")) {
                    tixi::TixiRemoveElement(tixiHandle, xpath + "/deltaZ1");
                }
            }
            
            // write element filletRadius
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/filletRadius");
            tixi::TixiSaveElement(tixiHandle, xpath + "/filletRadius", m_filletRadius);
            
            // write element cutoutType
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/cutoutType");
            tixi::TixiSaveElement(tixiHandle, xpath + "/cutoutType", CPACSFuselageCutOut_cutoutToString(m_cutoutType));
            
        }
        
        const std::string& CPACSFuselageCutOut::GetUID() const
        {
            return m_uID;
        }
        
        void CPACSFuselageCutOut::SetUID(const std::string& value)
        {
            if (m_uidMgr) {
                m_uidMgr->TryUnregisterObject(m_uID);
                m_uidMgr->RegisterObject(value, *this);
            }
            m_uID = value;
        }
        
        const boost::optional<std::string>& CPACSFuselageCutOut::GetName() const
        {
            return m_name;
        }
        
        void CPACSFuselageCutOut::SetName(const std::string& value)
        {
            m_name = value;
        }
        
        void CPACSFuselageCutOut::SetName(const boost::optional<std::string>& value)
        {
            m_name = value;
        }
        
        const boost::optional<std::string>& CPACSFuselageCutOut::GetDescription() const
        {
            return m_description;
        }
        
        void CPACSFuselageCutOut::SetDescription(const std::string& value)
        {
            m_description = value;
        }
        
        void CPACSFuselageCutOut::SetDescription(const boost::optional<std::string>& value)
        {
            m_description = value;
        }
        
        const double& CPACSFuselageCutOut::GetPositionX() const
        {
            return m_positionX;
        }
        
        void CPACSFuselageCutOut::SetPositionX(const double& value)
        {
            m_positionX = value;
        }
        
        const double& CPACSFuselageCutOut::GetReferenceY() const
        {
            return m_referenceY;
        }
        
        void CPACSFuselageCutOut::SetReferenceY(const double& value)
        {
            m_referenceY = value;
        }
        
        const double& CPACSFuselageCutOut::GetReferenceZ() const
        {
            return m_referenceZ;
        }
        
        void CPACSFuselageCutOut::SetReferenceZ(const double& value)
        {
            m_referenceZ = value;
        }
        
        const double& CPACSFuselageCutOut::GetReferenceAngle() const
        {
            return m_referenceAngle;
        }
        
        void CPACSFuselageCutOut::SetReferenceAngle(const double& value)
        {
            m_referenceAngle = value;
        }
        
        const CPACSPointXYZ& CPACSFuselageCutOut::GetOrientationVector() const
        {
            return m_orientationVector;
        }
        
        CPACSPointXYZ& CPACSFuselageCutOut::GetOrientationVector()
        {
            return m_orientationVector;
        }
        
        const boost::optional<CPACSPointXYZ>& CPACSFuselageCutOut::GetAlignmentVector() const
        {
            return m_alignmentVector;
        }
        
        boost::optional<CPACSPointXYZ>& CPACSFuselageCutOut::GetAlignmentVector()
        {
            return m_alignmentVector;
        }
        
        const double& CPACSFuselageCutOut::GetDeltaY() const
        {
            return m_deltaY;
        }
        
        void CPACSFuselageCutOut::SetDeltaY(const double& value)
        {
            m_deltaY = value;
        }
        
        const double& CPACSFuselageCutOut::GetDeltaZ() const
        {
            return m_deltaZ;
        }
        
        void CPACSFuselageCutOut::SetDeltaZ(const double& value)
        {
            m_deltaZ = value;
        }
        
        const boost::optional<double>& CPACSFuselageCutOut::GetDeltaY1() const
        {
            return m_deltaY1;
        }
        
        void CPACSFuselageCutOut::SetDeltaY1(const double& value)
        {
            m_deltaY1 = value;
        }
        
        void CPACSFuselageCutOut::SetDeltaY1(const boost::optional<double>& value)
        {
            m_deltaY1 = value;
        }
        
        const boost::optional<double>& CPACSFuselageCutOut::GetDeltaZ1() const
        {
            return m_deltaZ1;
        }
        
        void CPACSFuselageCutOut::SetDeltaZ1(const double& value)
        {
            m_deltaZ1 = value;
        }
        
        void CPACSFuselageCutOut::SetDeltaZ1(const boost::optional<double>& value)
        {
            m_deltaZ1 = value;
        }
        
        const double& CPACSFuselageCutOut::GetFilletRadius() const
        {
            return m_filletRadius;
        }
        
        void CPACSFuselageCutOut::SetFilletRadius(const double& value)
        {
            m_filletRadius = value;
        }
        
        const CPACSFuselageCutOut_cutout& CPACSFuselageCutOut::GetCutoutType() const
        {
            return m_cutoutType;
        }
        
        void CPACSFuselageCutOut::SetCutoutType(const CPACSFuselageCutOut_cutout& value)
        {
            m_cutoutType = value;
        }
        
        CPACSPointXYZ& CPACSFuselageCutOut::GetAlignmentVector(CreateIfNotExistsTag)
        {
            if (!m_alignmentVector)
                m_alignmentVector = boost::in_place(m_uidMgr);
            return *m_alignmentVector;
        }
        
        void CPACSFuselageCutOut::RemoveAlignmentVector()
        {
            m_alignmentVector = boost::none;
        }
        
    }
}
