// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSExternalObject.h>
#include "CCPACSAircraftModel.h"
#include "CPACSGenericGeometryComponents.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
    namespace generated
    {
        CPACSGenericGeometryComponents::CPACSGenericGeometryComponents(CCPACSAircraftModel* parent, CTiglUIDManager* uidMgr) :
            m_uidMgr(uidMgr)
        {
            //assert(parent != NULL);
            m_parent = parent;
        }
        
        CPACSGenericGeometryComponents::~CPACSGenericGeometryComponents() {}
        
        CCPACSAircraftModel* CPACSGenericGeometryComponents::GetParent() const
        {
            return m_parent;
        }
        
        CTiglUIDManager& CPACSGenericGeometryComponents::GetUIDManager()
        {
            return *m_uidMgr;
        }
        
        const CTiglUIDManager& CPACSGenericGeometryComponents::GetUIDManager() const
        {
            return *m_uidMgr;
        }
        
        void CPACSGenericGeometryComponents::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
        {
            // read element genericGeometryComponent
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/genericGeometryComponent")) {
                tixi::TixiReadElements(tixiHandle, xpath + "/genericGeometryComponent", m_genericGeometryComponents, reinterpret_cast<CCPACSExternalObjects*>(this), m_uidMgr);
            }
            
        }
        
        void CPACSGenericGeometryComponents::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
        {
            // write element genericGeometryComponent
            tixi::TixiSaveElements(tixiHandle, xpath + "/genericGeometryComponent", m_genericGeometryComponents);
            
        }
        
        const std::vector<unique_ptr<CCPACSExternalObject> >& CPACSGenericGeometryComponents::GetGenericGeometryComponents() const
        {
            return m_genericGeometryComponents;
        }
        
        std::vector<unique_ptr<CCPACSExternalObject> >& CPACSGenericGeometryComponents::GetGenericGeometryComponents()
        {
            return m_genericGeometryComponents;
        }
        
        CCPACSExternalObject& CPACSGenericGeometryComponents::AddGenericGeometryComponent()
        {
            m_genericGeometryComponents.push_back(make_unique<CCPACSExternalObject>(reinterpret_cast<CCPACSExternalObjects*>(this), m_uidMgr));
            return *m_genericGeometryComponents.back();
        }
        
        void CPACSGenericGeometryComponents::RemoveGenericGeometryComponent(CCPACSExternalObject& ref)
        {
            for (std::size_t i = 0; i < m_genericGeometryComponents.size(); i++) {
                if (m_genericGeometryComponents[i].get() == &ref) {
                    m_genericGeometryComponents.erase(m_genericGeometryComponents.begin() + i);
                    return;
                }
            }
            throw CTiglError("Element not found");
        }
        
    }
}
