// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "CPACSPlasticityCurvePoint.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "TixiHelper.h"

namespace tigl
{
    namespace generated
    {
        CPACSPlasticityCurvePoint::CPACSPlasticityCurvePoint() :
            m_tangentModulus(0), 
            m_trueStress(0) {}
        
        CPACSPlasticityCurvePoint::~CPACSPlasticityCurvePoint() {}
        
        void CPACSPlasticityCurvePoint::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
        {
            // read element tangentModulus
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/tangentModulus")) {
                m_tangentModulus = tixi::TixiGetElement<double>(tixiHandle, xpath + "/tangentModulus");
            }
            else {
                LOG(ERROR) << "Required element tangentModulus is missing at xpath " << xpath;
            }
            
            // read element trueStress
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/trueStress")) {
                m_trueStress = tixi::TixiGetElement<double>(tixiHandle, xpath + "/trueStress");
            }
            else {
                LOG(ERROR) << "Required element trueStress is missing at xpath " << xpath;
            }
            
        }
        
        void CPACSPlasticityCurvePoint::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
        {
            // write element tangentModulus
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/tangentModulus");
            tixi::TixiSaveElement(tixiHandle, xpath + "/tangentModulus", m_tangentModulus);
            
            // write element trueStress
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/trueStress");
            tixi::TixiSaveElement(tixiHandle, xpath + "/trueStress", m_trueStress);
            
        }
        
        const double& CPACSPlasticityCurvePoint::GetTangentModulus() const
        {
            return m_tangentModulus;
        }
        
        void CPACSPlasticityCurvePoint::SetTangentModulus(const double& value)
        {
            m_tangentModulus = value;
        }
        
        const double& CPACSPlasticityCurvePoint::GetTrueStress() const
        {
            return m_trueStress;
        }
        
        void CPACSPlasticityCurvePoint::SetTrueStress(const double& value)
        {
            m_trueStress = value;
        }
        
    }
}
