// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "CPACSPointListRelXYZVector.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "TixiHelper.h"

namespace tigl
{
    namespace generated
    {
        CPACSPointListRelXYZVector::CPACSPointListRelXYZVector() {}
        
        CPACSPointListRelXYZVector::~CPACSPointListRelXYZVector() {}
        
        void CPACSPointListRelXYZVector::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
        {
            // read element rX
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/rX")) {
                m_rX.ReadCPACS(tixiHandle, xpath + "/rX");
            }
            else {
                LOG(ERROR) << "Required element rX is missing at xpath " << xpath;
            }
            
            // read element rY
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/rY")) {
                m_rY.ReadCPACS(tixiHandle, xpath + "/rY");
            }
            else {
                LOG(ERROR) << "Required element rY is missing at xpath " << xpath;
            }
            
            // read element rZ
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/rZ")) {
                m_rZ.ReadCPACS(tixiHandle, xpath + "/rZ");
            }
            else {
                LOG(ERROR) << "Required element rZ is missing at xpath " << xpath;
            }
            
        }
        
        void CPACSPointListRelXYZVector::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
        {
            // write element rX
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/rX");
            m_rX.WriteCPACS(tixiHandle, xpath + "/rX");
            
            // write element rY
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/rY");
            m_rY.WriteCPACS(tixiHandle, xpath + "/rY");
            
            // write element rZ
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/rZ");
            m_rZ.WriteCPACS(tixiHandle, xpath + "/rZ");
            
        }
        
        const CCPACSStringVector& CPACSPointListRelXYZVector::GetRX() const
        {
            return m_rX;
        }
        
        CCPACSStringVector& CPACSPointListRelXYZVector::GetRX()
        {
            return m_rX;
        }
        
        const CCPACSStringVector& CPACSPointListRelXYZVector::GetRY() const
        {
            return m_rY;
        }
        
        CCPACSStringVector& CPACSPointListRelXYZVector::GetRY()
        {
            return m_rY;
        }
        
        const CCPACSStringVector& CPACSPointListRelXYZVector::GetRZ() const
        {
            return m_rZ;
        }
        
        CCPACSStringVector& CPACSPointListRelXYZVector::GetRZ()
        {
            return m_rZ;
        }
        
    }
}
