// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
    class CTiglUIDManager;
    class CCPACSWingSparPosition;
    class CCPACSWingSpars;
    
    namespace generated
    {
        // This class is used in:
        // CPACSWingSpar
        
        // generated from /xsd:schema/xsd:complexType[815]
        class CPACSSparPositions
        {
        public:
            TIGL_EXPORT CPACSSparPositions(CCPACSWingSpars* parent, CTiglUIDManager* uidMgr);
            
            TIGL_EXPORT virtual ~CPACSSparPositions();
            
            TIGL_EXPORT CCPACSWingSpars* GetParent() const;
            
            TIGL_EXPORT CTiglUIDManager& GetUIDManager();
            TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;
            
            TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
            TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;
            
            TIGL_EXPORT virtual const std::vector<unique_ptr<CCPACSWingSparPosition> >& GetSparPositions() const;
            TIGL_EXPORT virtual std::vector<unique_ptr<CCPACSWingSparPosition> >& GetSparPositions();
            
            TIGL_EXPORT virtual CCPACSWingSparPosition& AddSparPosition();
            TIGL_EXPORT virtual void RemoveSparPosition(CCPACSWingSparPosition& ref);
            
        protected:
            CCPACSWingSpars* m_parent;
            
            CTiglUIDManager* m_uidMgr;
            
            std::vector<unique_ptr<CCPACSWingSparPosition> > m_sparPositions;
            
        private:
            #ifdef HAVE_CPP11
            CPACSSparPositions(const CPACSSparPositions&) = delete;
            CPACSSparPositions& operator=(const CPACSSparPositions&) = delete;
            
            CPACSSparPositions(CPACSSparPositions&&) = delete;
            CPACSSparPositions& operator=(CPACSSparPositions&&) = delete;
            #else
            CPACSSparPositions(const CPACSSparPositions&);
            CPACSSparPositions& operator=(const CPACSSparPositions&);
            #endif
        };
    }
    
    // CPACSSparPositions is customized, use type CCPACSWingSparPositions directly
}
