// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSWingCell.h>
#include "CCPACSWingShell.h"
#include "CPACSWingCells.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
    namespace generated
    {
        CPACSWingCells::CPACSWingCells(CCPACSWingShell* parent, CTiglUIDManager* uidMgr) :
            m_uidMgr(uidMgr)
        {
            //assert(parent != NULL);
            m_parent = parent;
        }
        
        CPACSWingCells::~CPACSWingCells() {}
        
        CCPACSWingShell* CPACSWingCells::GetParent() const
        {
            return m_parent;
        }
        
        CTiglUIDManager& CPACSWingCells::GetUIDManager()
        {
            return *m_uidMgr;
        }
        
        const CTiglUIDManager& CPACSWingCells::GetUIDManager() const
        {
            return *m_uidMgr;
        }
        
        void CPACSWingCells::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
        {
            // read element cell
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/cell")) {
                tixi::TixiReadElements(tixiHandle, xpath + "/cell", m_cells, reinterpret_cast<CCPACSWingCells*>(this), m_uidMgr);
            }
            
        }
        
        void CPACSWingCells::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
        {
            // write element cell
            tixi::TixiSaveElements(tixiHandle, xpath + "/cell", m_cells);
            
        }
        
        const std::vector<unique_ptr<CCPACSWingCell> >& CPACSWingCells::GetCells() const
        {
            return m_cells;
        }
        
        std::vector<unique_ptr<CCPACSWingCell> >& CPACSWingCells::GetCells()
        {
            return m_cells;
        }
        
        CCPACSWingCell& CPACSWingCells::AddCell()
        {
            m_cells.push_back(make_unique<CCPACSWingCell>(reinterpret_cast<CCPACSWingCells*>(this), m_uidMgr));
            return *m_cells.back();
        }
        
        void CPACSWingCells::RemoveCell(CCPACSWingCell& ref)
        {
            for (std::size_t i = 0; i < m_cells.size(); i++) {
                if (m_cells[i].get() == &ref) {
                    m_cells.erase(m_cells.begin() + i);
                    return;
                }
            }
            throw CTiglError("Element not found");
        }
        
    }
}
