// Copyright (c) 2016 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <CCPACSMaterialDefinition.h>
#include <string>
#include <tixi.h>
#include "CPACSCap.h"
#include "CPACSPointX.h"
#include "tigl_internal.h"

namespace tigl
{
    class CTiglUIDManager;
    
    namespace generated
    {
        // This class is used in:
        // CPACSWingRibCrossSection
        
        // generated from /xsd:schema/xsd:complexType[944]
        class CPACSWingRibCell
        {
        public:
            TIGL_EXPORT CPACSWingRibCell(CTiglUIDManager* uidMgr);
            TIGL_EXPORT virtual ~CPACSWingRibCell();
            
            TIGL_EXPORT CTiglUIDManager& GetUIDManager();
            TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;
            
            TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
            TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;
            
            TIGL_EXPORT virtual const std::string& GetUID() const;
            TIGL_EXPORT virtual void SetUID(const std::string& value);
            
            TIGL_EXPORT virtual const std::string& GetFromRib() const;
            TIGL_EXPORT virtual void SetFromRib(const std::string& value);
            
            TIGL_EXPORT virtual const std::string& GetToRib() const;
            TIGL_EXPORT virtual void SetToRib(const std::string& value);
            
            TIGL_EXPORT virtual const CPACSPointX& GetRibRotation() const;
            TIGL_EXPORT virtual CPACSPointX& GetRibRotation();
            
            TIGL_EXPORT virtual const CCPACSMaterialDefinition& GetMaterial() const;
            TIGL_EXPORT virtual CCPACSMaterialDefinition& GetMaterial();
            
            TIGL_EXPORT virtual const CPACSCap& GetUpperCap() const;
            TIGL_EXPORT virtual CPACSCap& GetUpperCap();
            
            TIGL_EXPORT virtual const CPACSCap& GetLowerCap() const;
            TIGL_EXPORT virtual CPACSCap& GetLowerCap();
            
        protected:
            CTiglUIDManager* m_uidMgr;
            
            std::string              m_uID;
            std::string              m_fromRib;
            std::string              m_toRib;
            CPACSPointX              m_ribRotation;
            CCPACSMaterialDefinition m_material;
            CPACSCap                 m_upperCap;
            CPACSCap                 m_lowerCap;
            
        private:
            #ifdef HAVE_CPP11
            CPACSWingRibCell(const CPACSWingRibCell&) = delete;
            CPACSWingRibCell& operator=(const CPACSWingRibCell&) = delete;
            
            CPACSWingRibCell(CPACSWingRibCell&&) = delete;
            CPACSWingRibCell& operator=(CPACSWingRibCell&&) = delete;
            #else
            CPACSWingRibCell(const CPACSWingRibCell&);
            CPACSWingRibCell& operator=(const CPACSWingRibCell&);
            #endif
        };
    }
    
    // Aliases in tigl namespace
    #ifdef HAVE_CPP11
    using CCPACSWingRibCell = generated::CPACSWingRibCell;
    #else
    typedef generated::CPACSWingRibCell CCPACSWingRibCell;
    #endif
}
